﻿Imports System.Runtime.InteropServices
Public Class frmListViewGroupS
    <DllImport("user32.dll")>
    Private Shared Function SendMessage(ByVal window As IntPtr, ByVal message As Integer, ByVal wParam As Integer, ByVal lParam As IntPtr) As Integer
    End Function

    <StructLayout(LayoutKind.Sequential)>
    Public Structure LVGROUP
        Public cbSize As Integer
        Public mask As Integer
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pszHeader As String
        Public cchHeader As Integer
        <MarshalAs(UnmanagedType.LPTStr)>
        Public pszFooter As String
        Public cchFooter As Integer
        Public iGroupId As Integer
        Public stateMask As Integer
        Public state As Integer
        Public uAlign As Integer
    End Structure

    Public Enum GroupState
        COLLAPSIBLE = 8
        COLLAPSED = 1
        EXPANDED = 0
    End Enum

    Public Sub SetGroupCollapse(ByVal state As GroupState)
        For i As Integer = 0 To lvGroupS.Groups.Count - 1
            Dim group As New LVGROUP
            group.cbSize = Marshal.SizeOf(group)
            group.state = CType(state, Integer)
            group.mask = 4
            group.iGroupId = i
            Dim ip As IntPtr = IntPtr.Zero
            Try
                ip = Marshal.AllocHGlobal(group.cbSize)
                Marshal.StructureToPtr(group, ip, True)
                SendMessage(lvGroupS.Handle, &H1000 + 147, i, ip)
            Catch ex As Exception
                System.Diagnostics.Trace.WriteLine(ex.Message & Environment.NewLine & ex.StackTrace)
            Finally
                If (ip <> Nothing) Then Marshal.FreeHGlobal(ip)
            End Try
        Next
    End Sub

    Private Sub frmListView1_Load(sender As Object, e As EventArgs) Handles Me.Load
        'SetGroupCollapse(GroupState.COLLAPSIBLE)
    End Sub
End Class