﻿Imports Microsoft.VisualBasic.ControlChars
Public Class Errorhandler

	Public Shared Sub dgvError(sender As Object, e As DataGridViewDataErrorEventArgs)
		Dim dgv = DirectCast(sender, DataGridView)
		Dim comboCol = TryCast(dgv.Columns(e.ColumnIndex), DataGridViewComboBoxColumn)
		If comboCol IsNot Nothing AndAlso e.Context = (DataGridViewDataErrorContexts.Formatting Or DataGridViewDataErrorContexts.Display) _
			AndAlso TypeOf e.Exception Is ArgumentException Then
			Dim bsPK = DirectCast(comboCol.DataSource, BindingSource)
			Dim tbPK = bsPK.DataTable
			Dim defaultRow = tbPK.Rows.Cast(Of DataRow).FirstOrDefault(Function(rw) 0 = (rw.RowState And (DataRowState.Deleted Or DataRowState.Detached)))
			If defaultRow.NotNull Then
				dgv(e.ColumnIndex, e.RowIndex).Value = defaultRow(comboCol.ValueMember) ' gültigen PK-Wert einsetzen
				Return
			End If
		End If
		Msg("ColumnIndex: ", e.ColumnIndex, ", Context: ", e.Context, Lf, e.Exception.Message)
		'Return
		'	Select Case e.Context
		'		Case DataGridViewDataErrorContexts.Commit
		'			If TypeOf (e.Exception) Is NoNullAllowedException Then
		'				msgDgvError("keine Nullwerte erlaubt", e)
		'			ElseIf TypeOf (e.Exception) Is ConstraintException Then
		'				msgDgvError($"Constraint-Fehler: {e.Exception}", e)
		'			Else
		'				msgDgvError($"Commit-Fehler: {e.Exception}", e)
		'			End If
		'		Case DataGridViewDataErrorContexts.Formatting : msgDgvError($"Formatting-Fehler: {e.Exception}", e)
		'		Case DataGridViewDataErrorContexts.PreferredSize : msgDgvError($"PreferredSize-Fehler: {e.Exception}", e)
		'		Case DataGridViewDataErrorContexts.Display : msgDgvError($"Anzeigefehler: {e.Exception}", e)
		'		Case DataGridViewDataErrorContexts.Parsing : msgDgvError($"Parsing-Fehler: {e.Exception}", e)
		'		Case DataGridViewDataErrorContexts.ClipboardContent : msgDgvError("Fehler beim Kopieren, Daten konnten nicht umgewandelt werden", e)
		'		Case DataGridViewDataErrorContexts.CurrentCellChange : msgDgvError("Die letzte Zelle ist fehlerhaft", e)
		'		Case DataGridViewDataErrorContexts.LeaveControl : msgDgvError("Änderungen konnten nicht übernommen werden.", e)
		'		Case DataGridViewDataErrorContexts.RowDeletion : msgDgvError("Zeile konnte nicht gelöscht werden, bitte auf Fremdschlüssel prüfen", e)
		'	End Select
	End Sub
End Class
