﻿Public Module MessageBoxes
	Public Sub msgInformation(Nachricht As String)
		MessageBox.Show(Nachricht, "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)
	End Sub

	Public Sub Msg(ParamArray items As Object())
		MessageBox.Show(String.Concat(items))
	End Sub

	Public Sub msgEx(ex As Exception)
		MessageBox.Show(ex.Message)
	End Sub

	Public Sub msgExclamation(Nachricht As String)
		MessageBox.Show(Nachricht, "Wichtige Info", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
	End Sub

	Public Sub msgError(Nachricht As String)
		MessageBox.Show(Nachricht, "FEHLER", MessageBoxButtons.OK, MessageBoxIcon.Error)
	End Sub

	Public Function msgQuestionWarning(Nachricht As String) As DialogResult
		Return MessageBox.Show(Nachricht, "Warnung", MessageBoxButtons.YesNo, MessageBoxIcon.Warning)
	End Function

	Public Function msgQuestionInfo(Nachricht As String) As DialogResult
		Return MessageBox.Show(Nachricht, "Frage", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
	End Function

	Public Sub msgDgvError(Nachricht As String, e As DataGridViewDataErrorEventArgs)
		Dim result = MessageBox.Show(String.Concat(Nachricht, Environment.NewLine, "Wollen sie den Datensatz weiter bearbeiten?"),
						 "Achtung!!!", MessageBoxButtons.YesNo, MessageBoxIcon.Error)
		e.Cancel = (result = DialogResult.Yes) ' Werte nochmals editieren oder ganze Zeile verwerfen
	End Sub

	'Public Sub msgDebug(Bereich As String, Nachricht As String)
	'	Dim debugfrm As New frmDebug
	'	debugfrm.Rtxt.AppendText($"{Date.Now}: {Bereich} | {Nachricht}")
	'	debugfrm.Rtxt.ScrollToCaret()
	'End Sub
End Module
